
<?php


define ("MAX_ATTEMPTS", 3);
define ("USER_TIMEOUT", 30);  // definovany ve vterinach




class Autorizace {


  public static function uzivatelPrihlasen() {

    if (isset($_SESSION["prihlaseno"])) {
       $timestamp = time();

       if ($timestamp-$_SESSION["prihlaseno"]<USER_TIMEOUT) {  return true;  }
    } else { 
      return false; 
    }

  }



  public static function odhlasUzivatele() {

    if (isset($_SESSION["prihlaseno"])) {
       $_SESSION["prihlaseno"]=0; 
       // unset($_SESSION["prihlaseno"]);
    }

  }





  public static function prihlasenyUzivatelVykonalAkci() {

    // Ukol: bylo by mozne tuto aktivitu vykonavat v ramci metody uzivatelPrihlasen()? Bylo by to vhodne? Proc / proc ne?

    $timestamp = time();
    $_SESSION["prihlaseno"]=$timestamp;
  }




  public static function overUzivatele($uziv_jmeno, $heslo) {

    $user_details = UserFactory::getDetailsForUser($uziv_jmeno);


    //echo $user_details['heslo']."<br/>"; 
    //echo $user_details['pokusu']."<br/>";
    //echo (intval($user_details['pokusu'])>=MAX_ATTEMPTS)."<br/>";




    // Ukol:  Zde pridejte "desfirovani" hesla uzivatele z DB.  Heslo bude take sifrovano v miste vkladani uzivatele do databaze.
    //  Vyuzijte napriklad MD5 sifrovani - princip a priklad viz. napriklad  http://www.w3schools.com/php/func_string_md5.asp
    //  V pripade MD5 se nebude jednat o desifrovani hodnoty hesla, ale overeni zadane hodnoty hesla ve formulari proti zasifrovanemu obrazu hesla v DB.


    if (($uziv_jmeno != "") && ($heslo != "") && ($user_details['heslo'] == $heslo) && (intval($user_details['pokusu'])<MAX_ATTEMPTS)) {
      

       $timestamp = time();
       //echo $timestamp;

       

       // Ukol:   timestamp do session ukladejte pod klicem, ktery odpovida nazvu uzivatele. Jaky bude rozdil ve funkcnosti v tomto pripade? 
       $_SESSION["prihlaseno"]=$timestamp;


       UserFactory::setFailedAttempts($uziv_jmeno, 0);

       return "Uspesne prihlaseno.";


    } elseif (intval($user_details['pokusu'])>=MAX_ATTEMPTS) {


       return "Uzivatel ma zablokovany ucet po vice nez ".MAX_ATTEMPTS." neuspesnych pokusech o prihlaseni. Kontaktujte administratora.";

    } elseif ($user_details['heslo']=='') {

       return "Spatne uzivatelske jmeno.";

    } else {

       $provedenych_pokusu=intval($user_details['pokusu']);

       $provedenych_pokusu++;

       UserFactory::setFailedAttempts($uziv_jmeno, $provedenych_pokusu);

       $pokusu_zbyva = MAX_ATTEMPTS-$provedenych_pokusu;

       if ($pokusu_zbyva>0) {
         return "Spatne heslo. Mate jeste ".$pokusu_zbyva." pokus(y) na prihlaseni.";
       } else {
         return "Uzivatel ma zablokovany ucet po vice nez ".MAX_ATTEMPTS." neuspesnych pokusech o prihlaseni. Kontaktujte administratora.";
       }

    }



  }


}